///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Botica/Botica.cs 82    6/02/05 9:41p Eaddy $
//
//    File name:	Botica.cs
//   Created by:	Marc Eaddy
//   Created on:	04/05/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Botica/Botica.cs $
 * 
 * 82    6/02/05 9:41p Eaddy
 * o Moved some camera parameters into Botica
 * 
 * 81    6/02/05 9:27p Eaddy
 * o Now crossbow appears in front of the user if they are using keyboard
 * and mouse
 * o Now uses CombinerTransformer to create transformer hiearchies
 * 
 * 80    5/31/05 7:17p Eaddy
 * o Fixed bug where xbow wasn't positioned correctly when tracking wasn't
 * on
 * 
 * 79    5/31/05 2:58p Eaddy
 * o Trivial change
 * 
 * 78    5/30/05 11:51p Eaddy
 * o Fixed bug that was introduced when I added the walls
 * 
 * 77    5/30/05 7:51p Eaddy
 * o 'R' is now used for changing rendering mode.
 * 
 * 76    5/28/05 8:18p Eaddy
 * o Fixed some XML doc warnings
 * 
 * 75    5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 74    5/28/05 4:27a Eaddy
 * o Name change
 * 
 * 73    5/17/05 10:48p Eaddy
 * o Removed unused stuff
 * o Now uses the proper lab bounding volume when spawning the bots
 * 
 * 72    5/17/05 12:44a Eaddy
 * o Moved GetRandomWaypoint into ChaseAITransformer
 * 
 * 71    5/13/05 7:55p Jrw2005
 * worked on spawning a bit
 * 
 * 70    5/13/05 7:45p Eaddy
 * o Now uses fine grained CD when robot dies and falls
 * 
 * 69    5/13/05 7:28p Edp2002
 * FineGrainCD
 * 
 * 68    5/13/05 7:06p Eaddy
 * o Fixed bug where collision detection wasn't working since all robots
 * shared the same transformed matrix
 * 
 * 67    5/13/05 7:06p Jrw2005
 * no spawning underground
 * 
 * 66    5/13/05 6:36p Jrw2005
 * better spawn point generation
 * 
 * 65    5/13/05 4:58p Eaddy
 * o Name isn't needed
 * 
 * 64    5/13/05 3:34p Eaddy
 * o Fixed compile error
 * 
 * 63    5/13/05 3:18p Eaddy
 * o Testing the slowness problem
 * o Can now press N to add a new wave of robots
 * 
 * 62    5/13/05 11:39a Eaddy
 * o Minor tweaks
 * 
 * 61    5/13/05 11:37a Eaddy
 * o Fixed compile warnings
 * 
 * 60    5/09/05 6:37p Jrw2005
 * "level" basics in place (robot count increases by one each level)
 * tested using the K key
 * 
 * 59    5/09/05 5:10p Jrw2005
 * 
 * 58    5/07/05 2:14p Eaddy
 * o Now uses new p5 glove helper function (haven't tested yet)
 * 
 * 57    5/07/05 12:56p Eaddy
 * o Now disposes of stuff properly
 * 
 * 56    5/06/05 7:38p Edp2002
 * 
 * 55    5/06/05 7:28p Edp2002
 * 
 * 54    5/06/05 5:45p Eaddy
 * o Now uses hand tracker
 * 
 * 53    5/06/05 4:55p Edp2002
 * 
 * 52    5/06/05 4:04p Edp2002
 * 
 * 51    5/06/05 3:55p Eaddy
 * o Firing rate now saturates to 1/s
 * 
 * 50    5/06/05 3:21p Eaddy
 * o Added basic support for triggering using a P5 glove
 * 
 * 49    5/06/05 2:53p Edp2002
 * added Acceleration Transformer and changed DamagingNode
 * 
 * 48    4/25/05 6:45p Eaddy
 * o Changed Set method to set accessor
 * 
 * 47    4/25/05 4:59p Eaddy
 * o Changed Get methods to get accessors
 * 
 * 46    4/25/05 4:55p Eaddy
 * o Fixed assertion
 * 
 * 45    4/25/05 4:42p Eaddy
 * o Transformer no longer stores the Node. This eliminates an unnecessary
 * circular dependency
 * between Node and Transformer, allows Transformers to be reused, and
 * simplifies the design.
 * 
 * 44    4/25/05 4:36p Eaddy
 * o Comments
 * 
 * 43    4/25/05 4:30p Eaddy
 * o Comments
 * o Reorganized code for clarity
 * 
 * 42    4/25/05 4:02p Eaddy
 * o Comments
 * o Now accessor handles setting variable recursively
 * 
 * 41    4/25/05 2:14p Eaddy
 * o Sped up crossbow bolt
 * 
 * 40    4/25/05 1:45p Eaddy
 * o Fixed crash that occured when switching screens (bolt mesh needs to
 * be recreated)
 * o Fixed bug where key events were being stolen by Botica
 * o Can now toggle wireframe
 * 
 * 39    4/22/05 8:20p Jrw2005
 * 
 * 38    4/22/05 7:53p Edp2002
 * We now have a collidable damagable body for the hero ... a cylinder
 * 
 * 37    4/22/05 7:39p Eaddy
 * o Commented out invert transformer
 * 
 * 36    4/22/05 6:05p Edp2002
 * no more if "GEOM" garbage
 * 
 * 35    4/22/05 5:27p Edp2002
 * UNBREAK MY HEART
 * 
 * 34    4/22/05 5:18p Eaddy
 * o Got rid of all the controller classes
 * 
 * 33    4/22/05 4:59p Eaddy
 * o Renamed class to AdapterTransformer
 * 
 * 32    4/22/05 4:19p Jrw2005
 * 
 * 31    4/21/05 8:05p Edp2002
 * 
 * 30    4/21/05 7:49p Edp2002
 * LIGERHUNTER!
 * 
 * 29    4/21/05 7:22p Edp2002
 * bot_mod.x is the bot that works with collision detection
 * 
 * 28    4/21/05 6:53p Edp2002
 * new media ... target.x, bot.x, crossbow.x, bolt.x
 * 
 * 27    4/20/05 8:41p Edp2002
 * 
 * 26    4/20/05 8:36p Edp2002
 * fixes for boltTraker problems ... see email marc
 * 
 * 25    4/20/05 7:57p Edp2002
 * Liger now dies ... 
 * 
 * 24    4/20/05 6:42p Eaddy
 * o Cleaned up code
 * o Can now fire multiple bolts
 * 
 * 23    4/20/05 5:30p Eaddy
 * o Removed controllers. Now uses Transformer exclusively.
 * 
 * 22    4/20/05 5:00p Eaddy
 * o Now collision sticker is used for velocity transformer collision
 * 
 * 21    4/20/05 4:56p Eaddy
 * o Now bolt collision works
 * 
 * 20    4/20/05 3:51p Edp2002
 * stay liger ... go bolt
 * 
 * 19    4/20/05 3:37p Eaddy
 * o Almost working
 * 
 * 18    4/18/05 5:08p Jrw2005
 * 
 * 17    4/18/05 4:38p Eaddy
 * o Added Transformer code. Doesn't work yet.
 * 
 * 16    4/18/05 4:35p Jrw2005
 * 
 * 15    4/15/05 9:55p Eaddy
 * o Fixed bug where arrow didn't always reappear properly when switching
 * screens and using
 * full screen
 * 
 * 14    4/15/05 9:29p Eaddy
 * o Added arrow
 * 
 * 13    4/15/05 6:37p Eaddy
 * o Added bolt object to scene
 * 
 * 12    4/15/05 3:38p Edp2002
 * slowing down weird effect
 * 
 * 11    4/15/05 3:29p Edp2002
 * checks if colliding and stops
 * 
 * 10    4/15/05 3:19p Edp2002
 * merge issue fixed
 * 
 * 9     4/15/05 3:17p Edp2002
 * new Ghetto Collision detection ... and 2 passes
 * 
 * 8     4/15/05 3:03p Eaddy
 * o Renamed some methods
 * 
 * 7     4/08/05 7:20p Jrw2005
 * 
 * 6     4/08/05 4:31p Jrw2005
 * 
 * 5     4/08/05 12:52p Eaddy
 * o Fixed bug where tracked camera button did nothing
 * 
 * 4     4/06/05 7:02p Eaddy
 * o Fixed collision detection
 * 
 * 3     4/05/05 6:45p Eaddy
 * o Removed unused using statement
 * 
 * 2     4/05/05 5:10p Eaddy
 * o Engine is now a DLL so that other projects can reference it (e.g.
 * Botica)
 * o Added "Goblin" project which is an EXE that starts the Engine. Run
 * this, not Engine.
 * o Extracted all app config related code into separate app-specific
 * project called Botica
 */
 
using System;
using System.Diagnostics;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;
using System.Collections;

using Goblin.Engine.Scene;
using Goblin.Engine.Physics;
using Goblin.Engine.Devices;
using Goblin.Engine.Utilities;

namespace Goblin.Apps
{
	/// <summary>Engine Sample Class</summary>
	public class Botica : Goblin.Engine.IApp
	{
		/// <summary>
		/// Root of the Goblin object model
		/// </summary>
		Goblin.Engine.Engine engine = null;

		/// <summary>
		/// the device to use (gotten from initSceneGraph)
		/// </summary>
		Device device = null;

		/// <summary>
		/// Reusable collision listeners
		/// </summary>
		CollisionDamageControl collisionDamageControl = new CollisionDamageControl();
		CollisionSticker collisionSticker = new CollisionSticker();
		IgnoreCollision ignoreCollision = new IgnoreCollision();
		
		/// <summary> Node for the player </summary>
		DamagableNode hero;

		/// <summary>
		/// IS900 tracker base station
		/// </summary>
		InputDeviceDriver trackerDriver = null;

		/// <summary>
		/// Input device associated with the camera
		/// </summary>
		/// <remarks>
		/// Can be a FirstPersonCamera or a IS900 tracker mounted
		/// on top of a head-worn display
		/// </remarks>
		InputDevice_6DOF cameraTracker = null;

		//-------------------------------------------------
		// Crossbow variables
		//-------------------------------------------------

		/// <summary> Node for the crossbow object </summary>
		Node nodeCrossbow = null;

		/// <summary> Transformer for crossbow object </summary>
		Transformer crossbowXfrmer;
		
		/// <summary> Node for the bolt object </summary>
		DamagingNode nodeBolt = null;

		/// <summary> Reusable mesh for the bolt object </summary>
		Mesh meshBolt = null;

		/// <summary> Tracker associated with bolt when aiming crossbow </summary>
		InputDevice_6DOF boltTracker = null;	

		/// <summary> Helper flag for firing the bolt during FrameMove() </summary>
		bool fireBoltOnNextFrame = false;

		/// <summary> Enemy robot node </summary>
		ArrayList	robots = new ArrayList();

		int robotCounter = 0;

		Bounds spawnVolume = null;

		/// <summary> </summary>
		P5.P5Glove glove = new P5.P5Glove(0);

		/// <summary> </summary>
		const float FIRING_LAG = .5f; // secs

		/// <summary> </summary>
		float fireWaitTime = 0;

		//-------------------------------------------------
		// CTOR/DTOR
		//-------------------------------------------------

		/// <summary>
		/// DEFAULT CTOR (does nothing)
		/// </summary>
		public Botica()
		{ }

		/// <summary>
		/// Frees resources. Don't try to use the object after this.
		/// </summary>
		public void Dispose()
		{
			engine = null;

			if (hero != null)
			{
				hero.Dispose();
				hero = null;
			}

			if (nodeCrossbow != null)
			{
				nodeCrossbow.Dispose();
				nodeCrossbow = null;
			}

			if (nodeBolt != null)
			{
				nodeBolt.Dispose();
				nodeBolt = null;
			}

			if (meshBolt != null)
			{
				meshBolt.Dispose();
				meshBolt = null;
			}

			if (robots != null)
			{
				foreach (DamagableNode robot in robots)
				{
					robot.Dispose();
				}

				robots.Clear();
				robots = null;
			}

			if (glove != null)
			{
				glove.Dispose();
				glove = null;
			}

			if (spawnVolume != null)
			{
				spawnVolume.Dispose();
				spawnVolume = null;
			}
		}

		//-------------------------------------------------
		// METHODS
		//-------------------------------------------------

		/// <summary>
		/// Called by Goblin.Engine to allow application to cache the root of
		/// the Goblin.Engine object model and perform non-device-specific
		/// initialization.
		/// </summary>
		/// <remarks>Implements IApp.init()</remarks>
		/// <param name="engine">Root of the Goblin.Engine object model</param>
		public void Init(Goblin.Engine.Engine engine)
		{
			this.engine = engine;
			engine.trackedCameraBtn.Click += new EventHandler(OnUseTrackedCameraClicked);
			engine.keyEvent += new KeyboardCallback(this.OnKeyEvent);

			// Setup the camera's view parameters
			engine.dxFirstPersonCamera.SetViewParameters(	
				new Vector3(-5.0f, 2.0f, 3.0f),	// Initially we are 2m above the origin
				new Vector3(-5.0f, 2.0f, 5.0f)); // and looking in the positive z-direction
		}

		/// <summary>
		/// Called each time the device is initialized
		/// </summary>
		/// <remarks>
		/// Implements IApp.initSceneGraph(). You must (re-)initialize all
		/// device-dependent objects or you'll get an exception during rendering.
		/// </remarks>
		/// <param name="theDevice"></param>
		public void SceneGraphInit(Device theDevice)
		{
			device = theDevice;

			//---------------
			// LAB
			//---------------

			// Add lab model
			Node lab = new Node("lab");
			lab.AddXFile(device, "Lab_gaia_exporter.x", engine.sceneGraph.XFileManager);
			
			// Lab model contains all the "real" objects in our world
			lab.IsReal = true;
			
			// Specify objects we can't collide with
			lab.setCollidable(false, "Geom");
			//lab.setCollidable(false, "Floor");
			lab.setCollidable(false, "Calib");

			// Specify objects that shouldn't be rendered
			lab.setRenderable(false,"Geom");
			//lab.setRenderable(false,"Floor");
			//lab.setRenderable(false,"Calib");

			// Add lab to scene
			engine.sceneGraph.AddNode(lab);

			//---------------
			// BULLSEYE
			//---------------

			// Add bullseye target model
			DamagableNode bullseye = new DamagableNode("bullseye", 1);
			bullseye.AddXFile(device, "target.x", engine.sceneGraph.XFileManager);

			// Place target above lab door
			Transformer tgt = new Transformer();
			tgt.current.translate(-5.3f, 2f, 1.2f);
			
			bullseye.Transformer = tgt;

			// Add target to scene
			engine.sceneGraph.AddNode(bullseye);

			//---------------
			// CAMERA
			//---------------

			// Add camera
			engine.nodeCamera = new CameraNode("Camera #1");
			engine.sceneGraph.AddNode(engine.nodeCamera);

			// Initialize the camera to use either the tracker or
			// keyboard/mouse
			initCameraTransformer();

			//---------------
			// HERO
			//---------------

			// Add hero attached to camera
			float heroHeight = 2.0f;
			
			// For the purposes of collision detection, the hero's
			// geometry is approximated as a cylinder
			Mesh body = Mesh.Cylinder(device, 0.1f, 0.1f, heroHeight, 5, 5);

			hero = new DamagableNode("hero", 5);
			hero.SetMesh(device, "", body, null, null, "");

			// Don't render the cylinder, its just for collision detection
			hero.Renderable = false;

			Transformer rot = new Transformer();
			rot.current.translate(0, -heroHeight/2.0f, 0);
			rot.current.rotateX((float)Math.PI/2);

			hero.Transformer = rot;

			// Add hero cylinder to the scene as a child of the camera
			engine.nodeCamera.AppendChild(hero);

			//---------------
			// CROSSBOW
			//---------------

			loadCrossbow();
		}

		/// <summary>
		/// Called after all the application plug-ins have initialized the
		/// scene graph.
		/// </summary>
		/// <param name="device"></param>
		public void SceneGraphInited(Device device)
		{
			spawnVolume = new Bounds();

			ArrayList matches = new ArrayList();
			engine.sceneGraph.RootNode.find("Floor", matches);
			for(int i = 0; i < matches.Count; ++i)
			{
				Node node = (Node) matches[i];
				if (node.MyMeshCont != null)
					node.MyMeshCont.FineGrainCD = true;
				
				if (node.Name == "LabFloor_801")
					spawnVolume.set(node.Bounds);
			}

			matches = new ArrayList();
			engine.sceneGraph.RootNode.find("Wall", matches);
			for(int i = 0; i < matches.Count; ++i)
			{
				Node node = (Node) matches[i];
				if (node.MyMeshCont != null)
					node.MyMeshCont.FineGrainCD = true;
			}

			matches = new ArrayList();
			engine.sceneGraph.RootNode.find("Hallway", matches);
			for(int i = 0; i < matches.Count; ++i)
			{
				Node node = (Node) matches[i];
				if (node.MyMeshCont != null)
					node.MyMeshCont.FineGrainCD = true;
			}

			matches = new ArrayList();
			engine.sceneGraph.RootNode.find("Corridor", matches);
			for(int i = 0; i < matches.Count; ++i)
			{
				Node node = (Node) matches[i];
				if (node.MyMeshCont != null)
					node.MyMeshCont.FineGrainCD = true;

				if (node.Name == "S_Corridor_Sep_1001")
					spawnVolume.max.Y = node.Bounds.max.Y;
			}

			// Uncomment the code to display the spawn volume
			//Node vol = new Node("vol");
			//vol.Collidable = false;
			//vol.SetMesh(device, "", spawnVolume.createMesh(device), null, null, "");
			//engine.sceneGraph.AddNode(vol);

			//---------------
			// EVIL ROBOT
			//---------------

			createRobots();
		}

		/// <summary>
		/// Initializes the crossbow and bolt
		/// </summary>
		/// <remarks>Called during initSceneGraph()</remarks>
		private void loadCrossbow()
		{
			// Create crossbow
			nodeCrossbow = new Node("weapon");
			nodeCrossbow.AddXFile(device, "crossbow.x", engine.sceneGraph.XFileManager);

			// Since the crossbow is controlled by the tracker, we don't
			// perform collision detection on it
			nodeCrossbow.setAllCollidable(false);

			// Add crossbow to scene
			engine.sceneGraph.AddNode(nodeCrossbow);

			// Assign tracker to control the crossbow
			initCrossBowTransformer();

			// Create the crossbow bolt mesh once and reuse it
			meshBolt = Mesh.Cylinder(device, .05f, .025f, .5f, 10, 10);

			// Load the first bolt
			reloadCrossbow();
		}

		/// <summary>
		/// Creates a new bolt and attaches it to the crossbow
		/// </summary>
		/// <remarks>
		/// Called after each bolt is fired so that the crossbow
		/// always has a bolt in the barrel.
		/// </remarks>
		public void reloadCrossbow()
		{
			Debug.Assert(meshBolt != null);

			// Create the bolt
			nodeBolt = new DamagingNode("bolt", 1);
			nodeBolt.SetMesh(device, "", meshBolt, null, null,"");

			// While the bolt is attached to the crossbow, don't perform
			// collision detection on it
			nodeBolt.Collidable = false;

			nodeBolt.MyMeshCont.FineGrainCD = true;

			// Add bolt to scene (attached to crossbow)
			engine.sceneGraph.AddNode(nodeBolt);

			// Assign tracker to control the bolt
			initBoltTransformer();
		}

		/// <summary>
		/// Called before rendering the next frame
		/// </summary>
		/// <remarks>Implements IApp.FrameMove()</remarks>.
		/// <param name="device"></param>
		/// <param name="fps">Current frames per second</param>
		/// <param name="elapsedTime">Time since last frame</param>
		public void FrameMove(Device device, float fps, float elapsedTime)
		{
			if (fireWaitTime > 0)
				fireWaitTime -= elapsedTime;

			if (fireBoltOnNextFrame)
			{
				FireBang(device);
				fireWaitTime = FIRING_LAG;
				fireBoltOnNextFrame = false;
			}

			if (glove != null && glove.Initialized) 
			{
				glove.Process();

				if (glove.IsGesture((int) (P5.Fingers.Index | P5.Fingers.PartlyBent)) && 
					fireWaitTime <= 0)
				{
					fireBoltOnNextFrame = true;
				}
			}

			updateRobots();
		}

		/// <summary>
		/// Fires the bolt in the direction it is pointing
		/// </summary>
		/// <param name="device"></param>
		private void FireBang(Device device)
		{
			// Change the bolt transformer from the tracker to a velocity-
			// based transformer
			AccelerationTransformer velTransformer = new AccelerationTransformer(true);

			// Now the bolt is collidable
			nodeBolt.Collidable = true;

			// The bolt should stick and do damage to whatever it collides with
			velTransformer.AddCollisionListener(collisionSticker);
			velTransformer.AddCollisionListener(collisionDamageControl);

			Matrix trans = nodeBolt.CombinedTransformationMatrix;

			// Make sure the transformer starts at the bolt's current position
			velTransformer.current.position = trans;

			Vector3 point = new Vector3(0,0,1);
			trans.M41 = 0;
			trans.M42 = 0;
			trans.M43 = 0;
			point.TransformCoordinate(trans);
			point.Normalize();
			point *= 10f;
			velTransformer.Velocity = point;

			// Shoot the bolt
			nodeBolt.Transformer = velTransformer;

			// Load another crossbow bolt
			reloadCrossbow();
		}

		private void createRobots()
		{
			//make one more than the previous level had
			int num_to_create = robots.Count + 1;

			robots.Clear();

			MyTrace.Log("Adding " + num_to_create + " robots");

			for(int i = 0; i < num_to_create; ++i)
			{
				DamagableNode r = createRobot(spawnVolume);
				
				// Add robot to scene
				engine.sceneGraph.AddNode(r);
				
				// Add robot to our list of all of them
				robots.Add(r);
			}
		}

		/// <summary>
		/// puts a new robot on the map, with a randomized position
		/// which doesn't overlap with others
		/// 
		/// center and radius describe the sphere inside of which the robots are spawned
		/// 
		/// </summary>
		private DamagableNode createRobot(Bounds spawnVolume)
		{
			DamagableNode nodeRobot = new DamagableNode("robot " + robotCounter++, 1);
			nodeRobot.AddXFile(device, "bot_mod.x", engine.sceneGraph.XFileManager);

			// Create an AI controller that chases the player
			ChaseAITransformer ct = new ChaseAITransformer(hero, spawnVolume);
			ct.AddCollisionListener(collisionDamageControl);
			//AccelerationTransformer ct = new AccelerationTransformer(true);
			//Transformer ct = new Transformer();

			ct.current.scale(0.005f);
			ct.Speed = .3f;

			nodeRobot.Transformer = ct;

			MyTrace.Log("Created robot " + robotCounter);
			return nodeRobot;
		}

		private void updateRobots()
		{
			int aliveCount=0;
			foreach (DamagableNode nodeRobot in robots)
			{
				if ( !nodeRobot.isAlive )
				{
					AccelerationTransformer test = nodeRobot.Transformer as AccelerationTransformer;
					if ( test == null ) 
					{
						AccelerationTransformer acc = new AccelerationTransformer(true);
						acc.current = nodeRobot.Transformer.current.Copy();
						acc.Acceleration = new Vector3(0,-9.8f,0);
						nodeRobot.Transformer = acc;	
						nodeRobot.MyMeshCont.FineGrainCD = true;
					} 
					else if ( test.Acceleration.Length() == 0 && nodeRobot.Collidable )
					{
						MyTrace.WriteLine( "die" );
						nodeRobot.Collidable = false;
					}
				}//end if(!alive)

				else
					aliveCount++;
			}//end foreach

			//create the next wave of attackers!!
			if (aliveCount <= 0)
				createRobots();
		}

		/// <summary>
		/// Fires the bolt at the Robot
		/// </summary>
		private void hitRobot(DamagableNode nodeRobot)
		{
			// Change the bolt transformer from the tracker to a velocity-
			// based transformer
			AccelerationTransformer velTransformer = new AccelerationTransformer(true);

			// Now the bolt is collidable
			nodeBolt.Collidable = true;

			// The bolt should stick and do damage to whatever it collides with
			velTransformer.AddCollisionListener(collisionSticker);
			velTransformer.AddCollisionListener(collisionDamageControl);

			// Make sure the transformer starts at the bolt's current position
			Xfrm x = new Xfrm();
			Matrix m = engine.nodeCamera.CombinedTransformationMatrix;
			//m.Invert();
			//m.M41 = 0;
			//m.M42 = 0;
			//m.M43 = 0;
			//x.rotation = engine.nodeCamera.CombinedTransformationMatrix;
			x.rotateY(1.0f);
			x.translate(hero.getPosition()+new Vector3(0,1,0));

			Vector3 point = nodeRobot.getPosition()-(hero.getPosition()+new Vector3(0,1,0));
			point.Normalize();
			point *= 10f;

			velTransformer.current = x;
			velTransformer.Velocity = point;

			// Shoot the bolt
			nodeBolt.Transformer = velTransformer;
			hero.Collidable = false;
		}

		private DamagableNode getAliveRobot()
		{
			DamagableNode nodeRobot = null;
			foreach(DamagableNode n in robots)
			{
				if(n.isAlive)
				{
					nodeRobot = n;
					break;
				}
			}
			return nodeRobot;
		}

		//-------------------------------------------------
		// EVENT HANDLERS
		//-------------------------------------------------

		/// <summary>
		/// Called when the change device button is clicked
		/// </summary>
		private void OnUseTrackedCameraClicked(object sender, EventArgs e)
		{
			initCameraTransformer();
		}

		/// <summary>
		/// Called when a key is pressed
		/// </summary>
		private void OnKeyEvent(System.Windows.Forms.Keys key, bool isKeyDown, bool isKeyUp)
		{
			if (isKeyDown)
			{
				switch(key)
				{
					case System.Windows.Forms.Keys.Space:
						if (fireWaitTime <= 0)
							fireBoltOnNextFrame = true;
						break;

					case System.Windows.Forms.Keys.N:
						createRobots();
						break;

					case System.Windows.Forms.Keys.K:
						DamagableNode nodeRobot = getAliveRobot();
						if (nodeRobot != null)
						{
							hitRobot(nodeRobot);
							nodeRobot.Kill();
							MyTrace.WriteLine("KILL!");
						}
						break;

				}
			}
		}

		//-------------------------------------------------
		// HELPER METHODS
		//-------------------------------------------------

		bool initTrackerDriver()
		{
			if (trackerDriver == null)
			{
				trackerDriver = engine.inputMapper["InterSenseDriver"];
				if(trackerDriver == null)
				{
					MyTrace.Log(TraceLevel.Error, "Did not find mapped device named '"
						+ "InterSenseDriver" +"'");
				}
			}
			
			return trackerDriver != null;
		}

		void initCrossBowTransformer()
		{
			Debug.Assert(nodeCrossbow != null);

			// See if the IS900 tracker is available to track the bolt. We
			// are reusing the same tracker used to track the bolt.
			if (initNodeTracker("IS900_HandTracker", ref boltTracker))
			{
				Debug.Assert(boltTracker != null);
				crossbowXfrmer = new TrackerTransformer(boltTracker);
				
				crossbowXfrmer.current.scale(2.5f);
				crossbowXfrmer.current.rotateX((float)Geometry.DegreeToRadian(-90));
				crossbowXfrmer.current.rotateZ((float)(Math.PI*3.0/2.0));
				crossbowXfrmer.current.rotateY((float)(Math.PI/2.0));
			}
			else
			{
				CombinerTransformer combiner = new CombinerTransformer(engine.nodeCamera.Transformer);

				combiner.baseXfrm.scale(2.5f);
				combiner.baseXfrm.rotateX((float)Geometry.DegreeToRadian(-85));
				combiner.baseXfrm.rotateY((float)(Math.PI));
				combiner.baseXfrm.translate(0, -0.15f, 1f);

				crossbowXfrmer = combiner;
			}
				
			nodeCrossbow.Transformer = crossbowXfrmer;
		}

		void initBoltTransformer()
		{
			Debug.Assert(nodeBolt != null);
			Debug.Assert(crossbowXfrmer != null);

			CombinerTransformer boltXfrmer = new CombinerTransformer(crossbowXfrmer);

			boltXfrmer.baseXfrm.scale(0.5f);
			boltXfrmer.baseXfrm.rotateX((float)Geometry.DegreeToRadian(-5));
			//boltXfrmer.baseXfrm.rotateX((float)(-Math.PI/2.1));
			//boltXfrmer.baseXfrm.rotateY((float)(Math.PI));

			nodeBolt.Transformer = boltXfrmer;
		}

		void initCameraTransformer()
		{
			Debug.Assert(engine.nodeCamera != null);

			Transformer cameraXfrmer;

			// See if the IS900 tracker is available to track the bolt
			if (engine.useTrackedCamera && 
				initNodeTracker("IS900_HMDTracker", ref cameraTracker))
			{
				Debug.Assert(cameraTracker != null);
				cameraXfrmer = new TrackerTransformer(cameraTracker);
			}
			else
			{
				cameraXfrmer = new DXCameraTransformer(engine.dxFirstPersonCamera);
			}

			engine.nodeCamera.Transformer = cameraXfrmer;
		}

		/// <summary>
		/// Helper method for initializing an IS900 tracker. If the tracker was
		/// already initialized, method just returns true.
		/// </summary>
		/// <param name="name">Name of tracker. Must match the name in init_devices.xml.</param>
		/// <param name="tracker"></param>
		/// <returns>true if tracker is initialized</returns>
		bool initNodeTracker(string name, ref InputDevice_6DOF tracker)
		{
			if (tracker == null)
			{
				if (!initTrackerDriver())
					return false;

				Debug.Assert(trackerDriver != null);

				tracker = trackerDriver.GetInputByName(name) as InputDevice_6DOF;
				if (tracker == null)
				{
					MyTrace.Log(TraceLevel.Error, "Did not find mapped input named '" +
						name + "' (or it is not a 6DOF provider)");
				}
			}

			return tracker != null;
		}
	}
}
